'use strict';

let createModelAsync = (() => {
  var _ref = _asyncToGenerator(function* (modelConfig, models, globals) {
    // initialize models
    const sequelize = new Sequelize(modelConfig.database, modelConfig.username, modelConfig.password, {
      host: modelConfig.host,
      dialect: modelConfig.dialect,
      pool: modelConfig.pool,
      timezone: modelConfig.timezone,
      define: {
        timestamps: false,
        freezeTableName: true
      },
      logging: false
    });

    _.forEach(models, function (model, modelName) {
      model.unshift(modelName);
      sequelize.define.apply(sequelize, model);
    });
    globals.models = sequelize.models;
    globals.query = sequelize.query.bind(sequelize);
    globals.transaction = sequelize.transaction.bind(sequelize);
    return globals;
  });

  return function createModelAsync(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
})();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const Sequelize = require('sequelize');
const _ = require('lodash');

module.exports = createModelAsync;